<?php
if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}
get_lang($conf['name']);
include("config/config_links.php");

function menu($logo) {
	global $conf, $confl, $user;
	$navi = "[ <a href=\"index.php?name=".$conf['name']."\" title=\""._HOME."\">"._HOME."</a>";
	$navi .= ($confl['rate']) ? " | <a href=\"index.php?name=".$conf['name']."&best=1\" title=\""._BEST."\">"._BEST."</a> | <a href=\"index.php?name=".$conf['name']."&hits=1\" title=\""._POP."\">"._POP."</a>" : "";
	$navi .= " | <a href=\"index.php?name=".$conf['name']."&op=liste\" title=\""._LIST."\">"._LIST."</a>";
	if ((is_user($user) && $confl['addlinks'] == 1) || (!is_user($user) && $confl['addquest'] == 1)) $navi .= " | <a href=\"index.php?name=".$conf['name']."&op=add\" title=\""._ADD."\">"._ADD."</a>";
	$navi .= " ]";
	search($logo, $conf['name'], $navi);
}

function links() {
	global $prefix, $db, $admin, $admin_file, $pagetitle, $conf, $confl, $home, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$linknum = intval($confl['num']);
	$fbest = (intval($_GET['best'])) ? 1 : 0;
	$fhits = (intval($_GET['hits'])) ? 1 : 0;
	$lcat = (intval($_GET['cat'])) ? $_GET['cat'] : 0;
	if ($fbest && $confl['rate']) {
		$caton = 0;
		$field = "best=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY totalvotes DESC";
		$ordernum = "date <= now() AND status!='0'";
		$links_logo = ""._BEST."";
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." $links_logo";
	} elseif ($fhits && $confl['rate']) {
		$caton = 0;
		$field = "hits=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY hits DESC";
		$ordernum = "date <= now() AND status!='0'";
		$links_logo = ""._POP."";
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." $links_logo";
	} elseif ($lcat) {
		$caton = 1;
		$field = "cat=$lcat&";
		list($cat_title, $cat_description) = $db->sql_fetchrow($db->sql_query("SELECT title, description FROM ".$prefix."_categories WHERE id='$lcat'"));
		$order = "WHERE cid='$lcat' AND date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "cid='$lcat' AND date <= now() AND status!='0'";
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." $cat_title";
	} else {
		$caton = 1;
		$field = "";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "date <= now() AND status!='0'";
		$links_logo = ""._LINKS."";
		$pagetitle = "".$conf['defis']." $links_logo";
	}
	head();
	if (!$home) {
		if ($lcat) {
			menu($cat_title);
		} else {
			menu($links_logo);
		}
		if ($caton == 1) categories($conf['name'], $confl['tabcol'], $confl['subkat'], $confl['catdesc'], $lcat);
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $linknum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT f.lid, f.cid, f.title, f.description, UNIX_TIMESTAMP(f.date) as formatted, f.name, f.votes, f.totalvotes, f.totalcomments, f.hits, c.id, c.title, c.description, c.img FROM ".$prefix."_links AS f LEFT JOIN ".$prefix."_categories AS c ON (f.cid=c.id) ".$order." LIMIT $offset, $linknum");
	if ($db->sql_numrows($result) > 0) {
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script>";
		while (list($id, $fcid, $f_title, $description, $formatted, $aid, $votes, $totalvotes, $comment, $hits, $cid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result)) {
			$fp_data = date(""._DATESTRING."", $formatted);
			$title = "<a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"$f_title\"><b>$f_title</b></a> ".new_graphic($formatted)."";
			$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"left\"><a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"$f_title\"><b>"._READMORE."</b></a> | "._POSTEDBY.": ".user_info($aid, 1)."";
			if ($confl['date']) $link .= " | "._DATE.": ".$fp_data."";
			if ($confl['read']) $link .= " | "._LINKHITS.": ".$hits."";
			if ($confl['comm']) {
				if ($comment == 0) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$f_title\">"._COMMENTS."</a>";
				} elseif ($comment == 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$f_title\">"._COMMENT.": $comment</a>";
				} elseif ($comment > 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$f_title\">"._COMMENTS.": $comment</a>";
				}
			}
			if ($confl['pool']) $link .= (!$confl['votein']) ? "</td><td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$id', 'rate".$id."');</script><div class=\"rate\" id=\"rate".$id."\"></div></td>" : "</td><td><div class=\"rate\">".vote_graphic($votes, $totalvotes)."</div></td>";
			$link .= "<td align=\"right\"><a href=\"index.php?name=".$conf['name']."&op=printe&id=$id\"><img src=\"images/blocks/Print.gif\" border=\"0\" alt=\""._PRINTER."\" title=\""._PRINTER."\" align=\"center\"></a>";
			if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=links_add&id=$id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
			$link .= "</td></tr></table>";
			$cdescription = ($cdescription) ? $cdescription : $ctitle;
			$cimg = ($cimg) ? "<a href=\"index.php?name=".$conf['name']."&cat=$cid\"><img src=\"images/categories/".$cimg."\" border=\"0\" alt=\"$cdescription\" title=\"$cdescription\" align=\"right\" hspace=\"10\" vspace=\"10\"></a>" : "";
			basic($id, $fp_data, $title, $hits, cutstr(text_filter(bb_decode($description, $conf['name'])), 500), $link, $cid, $cimg, $ctitle);
		}
		num_article($conf['name'], $linknum, $field, "lid", "_links", "cid", $ordernum);
	}
	foot();
}

function liste() {
	global $db, $prefix, $pagetitle, $conf, $confl, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$linklistnum = intval($confl['listnum']);
	$let = (!preg_match("/[^a-zA-Z--0-9]/", $_GET['let'])) ? $_GET['let'] : "";
	if ($let) {
		$field = "op=liste&let=".urlencode($let)."&";
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." "._LIST." ".$conf['defis']." $let";
		$order = "WHERE UPPER(f.title) LIKE '".$let."%' AND date <= now() AND status!='0'";
	} else {
		$field = "op=liste&";
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." "._LIST."";
		$order = "WHERE date <= now() AND status!='0'";
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $linklistnum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT f.lid, f.cid, f.title, f.date, f.name, c.id, c.title FROM ".$prefix."_links AS f LEFT JOIN ".$prefix."_categories AS c ON (f.cid=c.id) ".$order." ".$lang." ORDER BY date DESC LIMIT $offset, $linklistnum");
	head();
	menu(""._LIST."");
	if ($db->sql_numrows($result) > 0) {
		OpenTable();
		if ($confl['letter']) letter($conf['name']);
		echo "<script language=\"JavaScript\" type=\"text/javascript\" src=\"ajax/SortTable.js\"></script><table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
		."<th>"._ID."</th><th>"._TITLE."</th><th>"._CATEGORY."</th><th>"._DATE."</th><th>"._POSTEDBY."</th></tr>";
		while (list($id, $catid, $stitle, $time, $aid, $cid, $ctitle) = $db->sql_fetchrow($result)) {
			$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$cid\" title=\"".$ctitle."\">".cutstr($ctitle, 10)."</a>";
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".$id."</td>"
			."<td><a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$stitle."\">".cutstr($stitle, 50)."</a></td>"
			."<td align=\"center\">".$ctitle."</td>"
			."<td align=\"center\">".formatTimestamp($time)."</td>"
			."<td align=\"center\">".user_info($aid, 1)."</td></tr>";
		}
		echo "</table>";
		CloseTable();
		$ordernum = ($let) ? "UPPER(title) LIKE '".$let."%' AND date <= now() AND status!='0'" : "date <= now() AND status!='0'";
		num_article($conf['name'], $linklistnum, $field, "lid", "_links", "cid", $ordernum);
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function printe() {
	global $prefix, $db, $pagetitle, $conf;
	$id = intval($_GET['id']);
	$result = $db->sql_query("SELECT f.cid, f.title, f.url, f.description, f.date, f.name, f.email, f.votes, f.totalvotes, f.totalcomments, f.hits, c.id, c.title, c.description, c.img FROM ".$prefix."_links AS f LEFT JOIN ".$prefix."_categories AS c ON (f.cid=c.id) WHERE lid='$id' AND date <= now() AND status!='0'");
	if ($db->sql_numrows($result) == 1) {
		list($cid, $title, $url, $description, $date, $aid, $a_email, $votes, $totalvotes, $totalcomments, $hits, $ccid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result);
		$ThemeSel = get_theme();
		if (file_exists("templates/$ThemeSel/index.php")) {
			require_once("templates/$ThemeSel/index.php");
		} else {
			require_once("function/template.php");
		}
		$conf['defis'] = urldecode($conf['defis']);
		$ftitle = (intval($ccid)) ? "$title ".$conf['defis']." $ctitle ".$conf['defis']." "._LINKS." ".$conf['defis']." ".$conf['sitename']."" : "$title ".$conf['defis']." "._LINKS." ".$conf['defis']." ".$conf['sitename']."";
		$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$ccid\" title=\"".$ctitle."\">".cutstr($ctitle, 10)."</a>";
		$ptitle = "".formatTimestamp($date)." - ".$title."";
		$text .= "<table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>"._POSTEDBY.": ".user_info($aid, 1)."</td><td>"._CATEGORY.": ".$ctitle."</td></tr>"
		."<tr><td>"._LINKHITS.": ".$hits."</td><td>"._DATE.": ".formatTimestamp($date)."</td></tr></table>"
		."<hr><table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>".bb_decode($description, $conf['name'])."</td></tr></table>";
		$url = ""._COMESFROM.": <a href=\"".$conf['homeurl']."\" title=\"".$conf['sitename']."\">".$conf['homeurl']."</a><br />"._THEURL.": <a href=\"".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$title."\">".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id</a>";
		prints($ftitle, $ptitle, $text, $url);
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function view() {
	global $hometext, $pagetitle, $prefix, $db, $admin, $admin_file, $conf, $confl, $datetime;
	$id = intval($_GET['id']);
	$word = ($_GET['word']) ? text_filter($_GET['word']) : "";
	$result = $db->sql_query("SELECT f.cid, f.title, f.url, f.description, f.date, f.name, f.email, f.votes, f.totalvotes, f.totalcomments, f.hits, c.id, c.title, c.description, c.img FROM ".$prefix."_links AS f LEFT JOIN ".$prefix."_categories AS c ON (f.cid=c.id) WHERE lid='$id' AND date <= now() AND status!='0'");
	if ($db->sql_numrows($result) == 1) {
		list($cid, $title, $url, $description, $date, $aid, $a_email, $votes, $totalvotes, $totalcomments, $hits, $ccid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result);
		$pagetitle = (intval($cid)) ? "".$conf['defis']." "._LINKS." ".$conf['defis']." $ctitle ".$conf['defis']." $title" : "".$conf['defis']." "._LINKS." ".$conf['defis']." $title";
		$hometext = $description;
		$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$ccid\" title=\"".$ctitle."\">".cutstr($ctitle, 15)."</a>";
		head();
		menu(""._LINKS."");
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script>";
		$text .= "<table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>"._POSTEDBY.": ".user_info($aid, 1)."</td><td>"._CATEGORY.": ".$ctitle."</td></tr>"
		."<tr><td>"._LINKHITS.": ".$hits."</td><td>"._DATE.": ".formatTimestamp($date)."</td></tr></table><hr>";
		$text .= "".search_color(bb_decode($description, $conf['name']), $word)."";
		$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>";
		if ($confl['pool']) $link .= "<td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$id', 'rate".$id."');</script><div class=\"rate\" id=\"rate".$id."\"></div></td>";
		if (is_user($user) || $confl['links'] == "1") {
			$link .= "<td align=\"center\"><form action=\"index.php?name=".$conf['name']."\" method=\"post\" style=\"display: inline\">"
			."<input type=\"hidden\" name=\"id\" value=\"$id\">"
			."<input type=\"hidden\" name=\"op\" value=\"geturl\">"
			."<input type=\"submit\" onClick=\"window.open('$url')\" value=\""._DOWNLLINK."\"></form></td>";
		}
		$link .= "<td align=\"right\"><a href=\"index.php?name=".$conf['name']."&op=printe&id=$id\" title=\""._PRINTER."\"><img src=\"images/blocks/Print.gif\" border=\"0\" align=\"center\"></a>";
		if ($confl['broc'] == 1) $link .= " <a href=\"index.php?name=".$conf['name']."&op=broken&id=$id\" title=\""._BROCLINK."\"><img src=\"images/warning.gif\" border=\"0\" align=\"center\"></a>";
		if (is_admin($admin) && $a_email) $link .= " <a href=\"mailto:".$a_email."\" title=\""._AUEMAIL."\"><img src=\"images/blocks/Contact.gif\" border=\"0\" align=\"center\"></a>";
		if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=links_add&id=$id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
		$link .= "</td></tr></table>";
		basic($id, $time, search_color($title, $word), $counter, $text, $link, $cid, "", $ctitle);
		if ($confl['comm']) {
			echo "<a name=\"$id\"></a>";
			show_com($id);
		}
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function broken() {
	global $prefix, $db, $pagetitle, $conf, $confl;
	$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." "._BROCLINK."";
	$id = intval($_GET['id']);
	if ($confl['broc'] == 1 && $id) {
		head();
		menu(""._BROCLINK."");
		$db->sql_query("UPDATE ".$prefix."_links SET status='2' WHERE lid='$id'");
		warning(""._BROCNOTEL."", "?name=".$conf['name']."&op=view&id=$id", 5, 2);
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function add() {
	global $db, $prefix, $user, $conf, $confu, $confl, $pagetitle, $userinfo, $stop;
	$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." "._ADD."";
	if ((is_user($user) && $confl['addlinks'] == 1) || (!is_user($user) && $confl['addquest'] == 1)) {
		if (is_user($user)) {
			getusrinfo($user);
			$author = (isset($_POST['author'])) ? $_POST['author'] : $userinfo['user_name'];
			$authormail = (isset($_POST['authormail'])) ? $_POST['authormail'] : $userinfo['user_email'];
			$linklink = (isset($_POST['linklink'])) ? $_POST['linklink'] : $userinfo['user_website'];
		} else {
			$author = (isset($_POST['author'])) ? $_POST['author'] : $confu['anonym'];
			$authormail = (isset($_POST['authormail'])) ? $_POST['authormail'] : "";
			$linklink = (isset($_POST['linklink'])) ? $_POST['linklink'] : "http://";
		}
		head();
		menu(""._ADD."");
		$info = ""._ADDFNOTE."";
		if ($stop) warning($stop, "", "", 1);
		warning($info, "", "", 2);
		if ($_POST['description']) preview("<b>".$_POST['title']."</b><br /><br />".nl2br(bb_decode(text_filter($_POST['description'], 2), $conf['name']))."");
		OpenTable();
		echo "<form name=\"post\" action=\"index.php?name=".$conf['name']."\" method=\"post\">"
		."<div class=\"left\">"._POSTEDBY.":</div><div class=\"center\"><input type=\"text\" name=\"author\" value=\"".$author."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._AUEMAIL.":</div><div class=\"center\"><input type=\"text\" name=\"authormail\" value=\"".$authormail."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._LTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"title\" value=\"".$_POST['title']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._CATEGORY.":</div><div class=\"center\"><select name=\"cid\" style=\"width: 400px\">".getcat($conf['name'], $_POST['cid'])."</select></div>"
		."<div class=\"left\">"._DESCRIPTION.":</div><div class=\"center\">".textarea("1", "description", "", $conf['name'], "10")."</div>"
		."<div class=\"left\">"._LINKLINK.":</div><div class=\"center\"><input type=\"text\" name=\"linklink\" value=\"".$linklink."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."".gfx_random().""
		."<div class=\"button\"><select name=\"posttype\">"
		."<option value=\"preview\">"._PREVIEW."</option>"
		."<option value=\"save\">"._SEND."</option></select>"
		."<input type=\"hidden\" name=\"op\" value=\"send\">"
		." <input type=\"submit\" value=\""._OK."\"></div></form>";
		CloseTable();
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function send() {
	global $prefix, $db, $user, $conf, $confl, $stop;
	if ((is_user($user) && $confl['addlinks'] == 1) || (!is_user($user) && $confl['addquest'] == 1)) {
		$title = text_filter($_POST['title']);
		$description = nl2br(text_filter($_POST['description'], 2));
		$linklink = ($_POST['linklink'] == "http://") ? "" : text_filter($_POST['linklink']);
		$author = text_filter($_POST['author']);
		$authormail = text_filter($_POST['authormail']);
		$cid = intval($_POST['cid']);
		$ip = getenv("REMOTE_ADDR");
		if (!$title) $stop = ""._CERROR."";
		if (!$description) $stop = ""._CERROR1."";
		checkemail($authormail);
		if (gfx_check()) $stop = ""._SECCODEINCOR."";
		if ($db->sql_numrows($db->sql_query("SELECT url FROM ".$prefix."_links WHERE url='$linklink'")) > 0) $stop = ""._LINKEXIST."";
		if (!$stop && $_POST['posttype'] == "save") {
			$db->sql_query("INSERT INTO ".$prefix."_links (lid, cid, title, description, url, date, name, email, ip_sender, status) VALUES (NULL, '$cid', '$title', '$description', '$linklink', now(), '$author', '$authormail', '$ip', '0')");
			update_points(15);
			head();
			menu(""._ADD."");
			warning(""._UPLOADFINISHL."", "?name=".$conf['name']."", 10, 2);
			foot();
		} else {
			add();
		}
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function geturl() {
	global $prefix, $db, $pagetitle, $conf, $confl;
	$id = intval($_POST['id']);
	if (($id && is_user($user)) || ($id && $confl['links'] == "1")) {
		$db->sql_query("UPDATE ".$prefix."_links SET hits=hits+1 WHERE lid=$id");
		list($f_title, $url) = $db->sql_fetchrow($db->sql_query("SELECT title, url FROM ".$prefix."_links WHERE lid='$id'"));
		update_points(17);
		$pagetitle = "".$conf['defis']." "._LINKS." ".$conf['defis']." $f_title";
		head();
		menu(""._LINKS."");
		OpenTable();
		echo "<center>"._NOTEDOWNLOADL." <b>$f_title</b> "._NOTEDOWNLOAD2L."<br /><br />"
		."<b><a href=\"$url\" target=\"_blank\">$url</a></b><br /><br /></center>";
		CloseTable();
		get_page($conf['name']);
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

switch($op) {
	default:
	links();
	break;
	
	case "liste":
	liste();
	break;
	
	case "printe":
	printe();
	break;
	
	case "view":
	view();
	break;
	
	case "geturl":
	geturl();
	break;
	
	case "broken":
	broken();
	break;
	
	case "add":
	add();
	break;
	
	case "send":
	send();
	break;

	case "save_com":
	save_com();
	break;
}
?>