<?php
if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}
get_lang($conf['name']);
include("config/config_jokes.php");

function menu($logo) {
	global $conf, $confj;
	$navi = "[ <a href=\"index.php?name=".$conf['name']."\" title=\""._HOME."\">"._HOME."</a>";
	$navi .= ($confj['rate']) ? " | <a href=\"index.php?name=".$conf['name']."&best=1\" title=\""._BEST."\">"._BEST."</a> | <a href=\"index.php?name=".$conf['name']."&hits=1\" title=\""._POP."\">"._POP."</a>" : "";
	if ((is_user($user) && $confj['add'] == 1) || (!is_user($user) && $confj['addquest'] == 1)) $navi .= " | <a href=\"index.php?name=".$conf['name']."&op=add\" title=\""._ADD."\">"._ADD."</a>";
	$navi .= " ]";
	search($logo, $conf['name'], $navi);
}

function jokes() {
	global $prefix, $db, $admin, $admin_file, $pagetitle, $conf, $home, $confj, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$word = ($_GET['word']) ? text_filter($_GET['word']) : "";
	$jokenum = intval($confj['jnum']);
	$jbest = (intval($_GET['best'])) ? 1 : 0;
	$jhits = (intval($_GET['hits'])) ? 1 : 0;
	$jcat = (intval($_GET['cat'])) ? $_GET['cat'] : 0;
	if ($jbest && $confj['rate']) {
		$caton = 0;
		$field = "best=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY ratingtot DESC";
		$ordernum = "date <= now() AND status!='0'";
		$jokes_logo = ""._BEST."";
		$pagetitle = "".$conf['defis']." "._JOKES." ".$conf['defis']." $jokes_logo";
	} elseif ($jhits && $confj['rate']) {
		$caton = 0;
		$field = "hits=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY rating DESC";
		$ordernum = "date <= now() AND status!='0'";
		$jokes_logo = ""._POP."";
		$pagetitle = "".$conf['defis']." "._JOKES." ".$conf['defis']." $jokes_logo";
	} elseif ($jcat) {
		$caton = 1;
		$field = "cat=$jcat&";
		list($cat_title, $cat_description) = $db->sql_fetchrow($db->sql_query("SELECT title, description FROM ".$prefix."_categories WHERE id='$jcat'"));
		$order = "WHERE cat='$jcat' AND date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "cat='$jcat' AND date <= now() AND status!='0'";
		$pagetitle = "".$conf['defis']." "._JOKES." ".$conf['defis']." $cat_title";
	} else {
		$caton = 1;
		$field = "";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "date <= now() AND status!='0'";
		$jokes_logo = ""._JOKES."";
		$pagetitle = "".$conf['defis']." $jokes_logo";
	}
	head();
	if (!$home) {
		if ($jcat) {
			menu($cat_title);
		} else {
			menu($jokes_logo);
		}
		if ($caton == 1) categories($conf['name'], $confj['tabcol'], $confj['subcat'], $confj['catdesc'], $jcat);
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $jokenum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT j.jokeid, j.author, UNIX_TIMESTAMP(j.date) as formatted, j.name, j.cat, j.joke, c.id, c.title, c.description, c.img FROM ".$prefix."_jokes AS j LEFT JOIN ".$prefix."_categories AS c ON (j.cat=c.id) ".$order." LIMIT $offset, $jokenum");
	if ($db->sql_numrows($result) > 0) {
		while (list($jokeid, $author, $formatted, $name, $cat, $joke, $cid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result)) {
			$j_data = date(""._DATESTRING."", $formatted);
			$title = "<a name=\"$jokeid\">".search_color($name, $word)."</a> ".new_graphic($formatted)."";
			$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"left\">"._POSTEDBY.": ".user_info($author, 1)." | "._CATEGORY.": <a href=\"index.php?name=".$conf['name']."&cat=$cat\" title=\"$ctitle\">$ctitle</a>";
			if ($confj['date']) $link .= " | "._DATE.": ".$j_data."";
			if ($confj['jpool']) $link .= "</td><td><script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$jokeid', 'rate".$jokeid."');</script><div class=\"rate\" id=\"rate".$jokeid."\"></div></td>";
			if (is_admin($admin)) $link .= "<td align=\"right\"><a href=\"".$admin_file.".php?op=jokes_add&id=$jokeid\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
			$link .= "</td></tr></table>";
			$cdescription = ($cdescription) ? $cdescription : $ctitle;
			$cimg = ($cimg) ? "<a href=\"index.php?name=".$conf['name']."&cat=$cid\"><img src=\"images/categories/".$cimg."\" border=\"0\" alt=\"$cdescription\" title=\"$cdescription\" align=\"right\" hspace=\"10\" vspace=\"10\"></a>" : "";
			basic($jokeid, $j_data, $title, $hits, search_color(bb_decode($joke, $conf['name']), $word), $link, $cid, $cimg, $ctitle);
		}
		num_article($conf['name'], $jokenum, $field, "jokeid", "_jokes", "cat", $ordernum);
	}
	foot();
}

function add() {
	global $db, $prefix, $confj, $user, $confu, $pagetitle, $conf, $userinfo, $stop;
	$pagetitle = "".$conf['defis']." "._JOKES." ".$conf['defis']." "._ADD."";
	if ($confj['add'] == "1") {
		head();
		menu(""._ADD."");
		if (is_user($user)) {
			getusrinfo($user);
			$author = (isset($_POST['author'])) ? $_POST['author'] : $userinfo['user_name'];
		} else {
			$author = (isset($_POST['author'])) ? $_POST['author'] : $confu['anonym'];
		}
		if ($stop) warning($stop, "", "", 1);
		warning(""._ADD_JNOTE."", "", "", 2);
		OpenTable();
		echo "<form name=\"post\" action=\"index.php?name=".$conf['name']."\" method=\"post\">"
		."<div class=\"left\">"._POSTEDBY.":</div><div class=\"center\"><input type=\"text\" name=\"author\" value=\"".$author."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._JTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"title\" value=\"".$_POST['title']."\"maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._CATEGORY.":</div><div class=\"center\"><select name=\"cid\" style=\"width: 400px\">".getcat($conf['name'], $_POST['cid'])."</select></div>"
		."<div class=\"left\">"._JOKE.":</div><div class=\"center\">".textarea("1", "joke", "", $conf['name'], "10")."</div>";
		if (extension_loaded("gd") && !is_user($user)) {
			$random = gen_pass(10);
			echo "<div class=\"left\">"._SECURITYCODE.":</div><div class=\"center\"><img src=\"index.php?gfx=gfx&random=$random\" border=\"1\" alt=\""._SECURITYCODE."\"></div>"
			."<div class=\"left\">"._TYPESECCODE.":</div><div class=\"center\"><input type=\"text\" name=\"gfx_check\" size=\"10\" maxlength=\"6\"></div>"
			."<input type=\"hidden\" name=\"random\" value=\"$random\">";
		}
		echo "<div class=\"button\"><input type=\"hidden\" name=\"op\" value=\"send\"><input type=\"submit\" value=\""._ADD."\"></div></form>";
		CloseTable();
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function send() {
	global $prefix, $db, $user, $conf, $confj, $stop;
	if ($confj['add'] == "1") {
		$author = text_filter(substr($_POST['author'], 0, 25));
		$title = text_filter($_POST['title']);
		$cid = intval($_POST['cid']);
		$joke = text_filter($_POST['joke']);
		if (!is_user($user)) {
			$code = substr(hexdec(md5("".date("F j")."".$_POST["random"]."".$conf['sitekey']."")), 2, 6);
			if (extension_loaded("gd") && $code != intval($_POST['gfx_check'])) $stop = ""._SECCODEINCOR."";
		}
		if ($db->sql_numrows($db->sql_query("SELECT name FROM ".$prefix."_jokes WHERE name='$title'")) > 0) $stop = ""._JOKEEXIST."";
		if (!$stop && $title && $joke && $author) {
			$db->sql_query("INSERT INTO ".$prefix."_jokes (jokeid, author, date, name, cat, joke, rating, ratingtot, status) VALUES (NULL, '$author', now(), '$title', '$cid', '$joke', '0', '0', '0')");
		} elseif ($stop) {
			$stop = $stop;
		} else {
			$stop = ""._UPLOADEROR."";
		}
		if (!$stop) {
			update_points(13);
			head();
			menu(""._ADD."");
			warning(""._UPLOADFINISHJ."", "?name=".$conf['name']."", 10, 2);
			foot();
		} else {
			add();
		}
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

switch($op) {
	default:
	jokes();
	break;
	
	case "add":
	add();
	break;
	
	case "send":
	send();
	break;
}
?>