<?php
if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}
get_lang($conf['name']);
include("config/config_media.php");

function menu($logo) {
	global $conf, $confm;
	$navi = "[ <a href=\"index.php?name=".$conf['name']."\" title=\""._HOME."\">"._HOME."</a>";
	$navi .= ($confm['rate']) ? " | <a href=\"index.php?name=".$conf['name']."&best=1\" title=\""._BEST."\">"._BEST."</a> | <a href=\"index.php?name=".$conf['name']."&hits=1\" title=\""._POP."\">"._POP."</a>" : "";
	$navi .= " | <a href=\"index.php?name=".$conf['name']."&op=liste\" title=\""._LIST."\">"._LIST."</a>";
	if ((is_user($user) && $confm['add'] == 1) || (!is_user($user) && $confm['addquest'] == 1)) $navi .= " | <a href=\"index.php?name=".$conf['name']."&op=add\" title=\""._ADD."\">"._ADD."</a>";
	$navi .= " ]";
	search($logo, $conf['name'], $navi);
}

function media() {
	global $prefix, $db, $admin, $admin_file, $pagetitle, $conf, $home, $confm, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$mnum = intval($confm['num']);
	$mbest = (intval($_GET['best'])) ? 1 : 0;
	$mhits = (intval($_GET['hits'])) ? 1 : 0;
	$mcat = (intval($_GET['cat'])) ? $_GET['cat'] : 0;
	if ($mbest && $confm['rate']) {
		$caton = 0;
		$field = "best=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY totalvotes DESC";
		$ordernum = "date <= now() AND status!='0'";
		$media_logo = ""._BEST."";
		$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." $media_logo";
	} elseif ($mhits && $confm['rate']) {
		$caton = 0;
		$field = "hits=1&";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY hits DESC";
		$ordernum = "date <= now() AND status!='0'";
		$media_logo = ""._POP."";
		$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." $media_logo";
	} elseif ($mcat) {
		$caton = 1;
		$field = "cat=$mcat&";
		list($cat_title, $cat_description) = $db->sql_fetchrow($db->sql_query("SELECT title, description FROM ".$prefix."_categories WHERE id='$mcat'"));
		$order = "WHERE cid='$mcat' AND date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "cid='$mcat' AND date <= now() AND status!='0'";
		$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." $cat_title";
	} else {
		$caton = 1;
		$field = "";
		$order = "WHERE date <= now() AND status!='0' ".$lang." ORDER BY date DESC";
		$ordernum = "date <= now() AND status!='0'";
		$media_logo = ""._MEDIA."";
		$pagetitle = "".$conf['defis']." $media_logo";
	}
	head();
	if (!$home) {
		if ($mcat) {
			menu($cat_title);
		} else {
			menu($media_logo);
		}
		if ($caton == 1) categories($conf['name'], $confm['tabcol'], $confm['subkat'], $confm['catdesc'], $mcat);
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $mnum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT m.id, m.cid, m.title, m.subtitle, m.director, m.roles, m.description, m.placed, UNIX_TIMESTAMP(m.date) as formatted, m.votes, m.totalvotes, m.totalcom, m.hits, c.id, c.title, c.description, c.img FROM ".$prefix."_media AS m LEFT JOIN ".$prefix."_categories AS c ON (m.cid=c.id) ".$order." LIMIT $offset, $mnum");
	if ($db->sql_numrows($result) > 0) {
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script>";
		while (list($id, $cid, $title, $subtitle, $director, $roles, $description, $placed, $formatted, $votes, $totalvotes, $totalcom, $hits, $ccid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result)) {
			$fp_data = date(""._DATESTRING."", $formatted);
			$m_title = ($subtitle) ? "".$title." ".urldecode($confm['defis'])." ".$subtitle."" : $title;
			$info = ($director && $roles) ? "<br /><br /><b>"._MDIRECTOR.":</b> ".cutstr($director, 65)."<br /><b>"._MROLES.":</b> ".cutstr($roles, 65)."" : "";
			$text = "".cutstr(bb_decode($description, $conf['name']), 800)."".$info."";
			$title = "<a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"$m_title\">$m_title</a> ".new_graphic($formatted)."";
			$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"left\"><a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"$m_title\"><b>"._READMORE."</b></a> | "._POSTEDBY.": ".user_info($placed, 1)."";
			if ($confm['date']) $link .= " | "._DATE.": ".$fp_data."";
			if ($confm['read']) $link .= " | "._READS.": ".$hits."";
			if ($confm['comm']) {
				if ($totalcom == 0) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$m_title\">"._COMMENTS."</a>";
				} elseif ($totalcom == 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$m_title\">"._COMMENT.": $totalcom</a>";
				} elseif ($totalcom > 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$id#$id\" title=\"$m_title\">"._COMMENTS.": $totalcom</a>";
				}
			}
			if ($confm['pooll']) $link .= (!$confm['votein']) ? "</td><td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$id', 'rate".$id."');</script><div class=\"rate\" id=\"rate".$id."\"></div></td>" : "</td><td><div class=\"rate\">".vote_graphic($votes, $totalvotes)."</div></td>";
			$link .= "<td align=\"right\"><a href=\"index.php?name=".$conf['name']."&op=printe&id=$id\"><img src=\"images/blocks/Print.gif\" border=\"0\" alt=\""._PRINTER."\" title=\""._PRINTER."\" align=\"center\"></a>";
			if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=media_add&id=$id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
			$link .= "</td></tr></table>";
			$cdescription = ($cdescription) ? $cdescription : $ctitle;
			$cimg = ($cimg) ? "<a href=\"index.php?name=".$conf['name']."&cat=$cid\"><img src=\"images/categories/".$cimg."\" border=\"0\" alt=\"$cdescription\" title=\"$cdescription\" align=\"right\" hspace=\"10\" vspace=\"10\"></a>" : "";
			basic($id, $fp_data, $title, $hits, $text, $link, $cid, $cimg, $ctitle);
		}
		num_article($conf['name'], $mnum, $field, "id", "_media", "cid", $ordernum);
	}
	foot();
}

function liste() {
	global $db, $prefix, $pagetitle, $conf, $confm, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$listnum = intval($confm['listnum']);
	$let = (!preg_match("/[^a-zA-Z--0-9]/", $_GET['let'])) ? $_GET['let'] : "";
	if ($let) {
		$field = "op=liste&let=".urlencode($let)."&";
		$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." "._LIST." ".$conf['defis']." $let";
		$order = "WHERE UPPER(m.title) LIKE '".$let."%' AND date <= now() AND status!='0'";
	} else {
		$field = "op=liste&";
		$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." "._LIST."";
		$order = "WHERE date <= now() AND status!='0'";
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $listnum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT m.id, m.cid, m.title, m.subtitle, m.date, m.placed, c.id, c.title FROM ".$prefix."_media AS m LEFT JOIN ".$prefix."_categories AS c ON (m.cid=c.id) ".$order." ".$lang." ORDER BY date DESC LIMIT $offset, $listnum");
	head();
	menu(""._LIST."");
	if ($db->sql_numrows($result) > 0) {
		OpenTable();
		if ($confm['letter']) letter($conf['name']);
		echo "<script language=\"JavaScript\" type=\"text/javascript\" src=\"ajax/SortTable.js\"></script><table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
		."<th>"._ID."</th><th>"._TITLE."</th><th>"._CATEGORY."</th><th>"._DATE."</th><th>"._POSTEDBY."</th></tr>";
		while (list($id, $catid, $title, $subtitle, $date, $placed, $cid, $ctitle) = $db->sql_fetchrow($result)) {
			$m_title = ($subtitle) ? "".$title." ".urldecode($confm['defis'])." ".$subtitle."" : $title;
			$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$cid\" title=\"".$ctitle."\">".cutstr($ctitle, 10)."</a>";
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".$id."</td>"
			."<td><a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$m_title."\">".cutstr($m_title, 50)."</a></td>"
			."<td align=\"center\">".$ctitle."</td>"
			."<td align=\"center\">".formatTimestamp($date)."</td>"
			."<td align=\"center\">".user_info($placed, 1)."</td></tr>";
		}
		echo "</table>";
		CloseTable();
		$ordernum = ($let) ? "UPPER(title) LIKE '".$let."%' AND date <= now() AND status!='0'" : "date <= now() AND status!='0'";
		num_article($conf['name'], $listnum, $field, "id", "_media", "cid", $ordernum);
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function printe() {
	global $prefix, $db, $pagetitle, $conf, $confm;
	$id = intval($_GET['id']);
	$result = $db->sql_query("SELECT m.cid, m.title, m.subtitle, m.director, m.roles, m.description, m.date, m.placed, m.hits, c.id, c.title FROM ".$prefix."_media AS m LEFT JOIN ".$prefix."_categories AS c ON (m.cid=c.id) WHERE m.id='$id' AND m.date <= now() AND status!='0'");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_media SET hits=hits+1 WHERE id='$id'");
		list($cid, $title, $subtitle, $director, $roles, $description, $date, $placed, $hits, $ccid, $ctitle) = $db->sql_fetchrow($result);
		$ThemeSel = get_theme();
		if (file_exists("templates/$ThemeSel/index.php")) {
			require_once("templates/$ThemeSel/index.php");
		} else {
			require_once("function/template.php");
		}
		$conf['defis'] = urldecode($conf['defis']);
		$m_title = ($subtitle) ? "".$title." ".urldecode($confm['defis'])." ".$subtitle."" : $title;
		$ftitle = (intval($ccid)) ? "$m_title ".$conf['defis']." $ctitle ".$conf['defis']." "._MEDIA." ".$conf['defis']." ".$conf['sitename']."" : "$m_title ".$conf['defis']." "._MEDIA." ".$conf['defis']." ".$conf['sitename']."";
		$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$ccid\" title=\"".$ctitle."\">".cutstr($ctitle, 10)."</a>";
		$ptitle = "".formatTimestamp($date)." - ".$m_title."";
		$info = ($director && $roles) ? "<br /><br /><b>"._MDIRECTOR.":</b> ".$director."<br /><b>"._MROLES.":</b> ".$roles."" : "";
		$text .= "<table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>"._POSTEDBY.": ".user_info($placed, 1)."</td><td>"._CATEGORY.": ".$ctitle."</td></tr>"
		."<tr><td>"._READS.": ".$hits."</td><td>"._DATE.": ".formatTimestamp($date)."</td></tr></table>"
		."<hr><table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>".bb_decode($description, $conf['name'])."".$info."</td></tr></table>";
		$url = ""._COMESFROM.": <a href=\"".$conf['homeurl']."\" title=\"".$conf['sitename']."\">".$conf['homeurl']."</a><br />"._THEURL.": <a href=\"".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$title."\">".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id</a>";
		prints($ftitle, $ptitle, $text, $url);
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function view() {
	global $hometext, $pagetitle, $prefix, $db, $admin, $admin_file, $conf, $confm;
	$id = intval($_GET['id']);
	$word = ($_GET['word']) ? text_filter($_GET['word']) : "";
	$result = $db->sql_query("SELECT m.id, m.cid, m.title, m.subtitle, m.year, m.director, m.roles, m.description, m.createdby, m.duration, m.lang, m.note, m.format, m.quality, m.size, m.released, m.placed, m.links, m.date, m.votes, m.totalvotes, m.totalcom, m.hits, m.status, c.id, c.title, c.description, c.img FROM ".$prefix."_media AS m LEFT JOIN ".$prefix."_categories AS c ON (m.cid=c.id) WHERE m.id='$id' AND date <= now() AND status!='0'");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_media SET hits=hits+1 WHERE id='$id'");
		list($id, $cid, $title, $subtitle, $year, $director, $roles, $description, $createdby, $duration, $lang, $note, $format, $quality, $size, $released, $placed, $links, $date, $votes, $totalvotes, $totalcom, $hits, $status, $ccid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result);
		$ptitle = ($subtitle) ? "".$title." ".urldecode($confm['defis'])." ".$subtitle."" : $title;
		$pagetitle = (intval($cid)) ? "".$conf['defis']." "._MEDIA." ".$conf['defis']." $ctitle ".$conf['defis']." $ptitle" : "".$conf['defis']." "._MEDIA." ".$conf['defis']." $ptitle";
		$hometext = $description;
		$title = ($subtitle) ? "".$title." ".urldecode($confm['defis'])." ".$subtitle."" : $title;
		$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$ccid\" title=\"".$ctitle."\">".cutstr($ctitle, 15)."</a>";
		head();
		menu(""._MEDIA."");
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script>";
		$text = "<table border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"><tr><td>"._POSTEDBY.": ".user_info($placed, 1)."</td><td>"._CATEGORY.": ".$ctitle."</td></tr>"
		."<tr><td>"._READS.": ".$hits."</td><td>"._DATE.": ".formatTimestamp($date)."</td></tr></table><hr>";
		$text .= "".search_color(bb_decode($description, $conf['name']), $word)."";
		$text .= ($year) ? "<br /><br /><b>"._MYEAR.":</b> ".$year."<br />" : "<br /><br />";
		$text .= ($director) ? "<b>"._MDIRECTOR.":</b> ".$director."<br />" : "";
		$text .= ($roles) ? "<b>"._MROLES.":</b> ".$roles."<br />" : "";
		$text .= ($createdby) ? "<b>"._MCREATEDBY.":</b> ".$createdby."<br />" : "";
		$text .= ($duration) ? "<b>"._MDURATION.":</b> ".$duration."<br />" : "";
		$text .= ($lang) ? "<b>"._LANGUAGE.":</b> ".$lang."<br />" : "";
		$text .= ($note) ? "<b>"._NOTE.":</b> ".bb_decode($note, $conf['name'])."" : "";
		$text .= ($format) ? "<br /><br /><b>"._MFORMAT.":</b> ".$format."<br />" : "<br /><br />";
		$text .= ($quality) ? "<b>"._MQUALITY.":</b> ".$quality."<br />" : "";
		$text .= ($size) ? "<b>"._MSIZE.":</b> ".$size."<br />" : "";
		$text .= ($released) ? "<b>"._MRELEASED.":</b> ".$released."" : "";
		if ($links) {
			$text .= "<br /><br /><b>"._URL.":</b> ";
			if ((is_user($user) && $confm['hide'] == "0") || $confm['hide'] == "1") {
				$links = explode(",", $links);
				$i = 1;
				foreach ($links as $val) {
					if ($val != "") {
						if ($i == 1) {
							$text .= "<a href=\"".$val."\" target=\"_blank\" title=\""._URL." - $i\">"._URL." - $i</a>";
						} else {
							$text .= " <img src=\"images/navi.gif\" border=\"0\" alt=\""._URL." - $i\"> <a href=\"".$val."\" target=\"_blank\" title=\""._URL." - $i\">"._URL." - $i</a>";
						}
						$i++;
					}
				}
			} else {
				$text .= ""._HIDETEXT."";
			}
		}
		$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>";
		if ($confm['pooll']) $link .= "<td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$id', 'rate".$id."');</script><div class=\"rate\" id=\"rate".$id."\"></div></td>";
		$link .= "<td align=\"right\"><a href=\"index.php?name=".$conf['name']."&op=printe&id=$id\" title=\""._PRINTER."\"><img src=\"images/blocks/Print.gif\" border=\"0\" align=\"center\"></a>";
		if ($confm['broc'] == 1) $link .= " <a href=\"index.php?name=".$conf['name']."&op=broken&id=$id\" title=\""._BROCMEDIA."\"><img src=\"images/warning.gif\" border=\"0\" align=\"center\"></a>";
		if (is_admin($admin) && $a_email) $link .= " <a href=\"mailto:".$a_email."\" title=\""._AUEMAIL."\"><img src=\"images/blocks/Contact.gif\" border=\"0\" align=\"center\"></a>";
		if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=media_add&id=$id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
		$link .= "</td></tr></table>";
		basic($id, $date, search_color($title, $word), $hits, $text, $link, $cid, "", $ctitle);
		if ($confm['comm']) {
			echo "<a name=\"$id\"></a>";
			show_com($id);
		}
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function broken() {
	global $prefix, $db, $pagetitle, $conf, $confm;
	$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." "._BROCMEDIA."";
	$id = intval($_GET['id']);
	if ($confm['broc'] == 1 && $id) {
		head();
		menu(""._BROCMEDIA."");
		$db->sql_query("UPDATE ".$prefix."_media SET status='2' WHERE id='$id'");
		warning(""._BROCNOTEM."", "?name=".$conf['name']."&op=view&id=$id", 5, 2);
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function add() {
	global $db, $prefix, $user, $confu, $pagetitle, $conf, $userinfo, $stop, $confm;
	$pagetitle = "".$conf['defis']." "._MEDIA." ".$conf['defis']." "._ADD."";
	if ((is_user($user) && $confm['add'] == 1) || (!is_user($user) && $confm['addquest'] == 1)) {
		if (is_user($user)) {
			getusrinfo($user);
			$author = (isset($_POST['author'])) ? $_POST['placed'] : $userinfo['user_name'];
		} else {
			$author = (isset($_POST['placed'])) ? $_POST['placed'] : $confu['anonym'];
		}
		$m_title = (isset($_POST['subtitle'])) ? "".$_POST['title']." ".urldecode($confm['defis'])." ".$_POST['subtitle']."" : $_POST['title'];
		head();
		menu(""._ADD."");
		if ($stop) warning($stop, "", "", 1);
		warning(""._ADDNOTEM."", "", "", 2);
		if ($_POST['description']) preview("<b>".$m_title."</b><br /><br />".nl2br(bb_decode(text_filter($_POST['description'], 2), $conf['name']))."");
		OpenTable();
		echo "<script language=\"JavaScript\" type=\"text/javascript\" src=\"ajax/SwitchMenu.js\"></script>"
		."<form name=\"post\" action=\"index.php?name=".$conf['name']."\" method=\"post\">"
		."<div class=\"left\">"._POSTEDBY.":</div><div class=\"center\"><input type=\"text\" name=\"placed\" value=\"$author\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._MTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"title\" value=\"".$_POST['title']."\"maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._MSUBTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"subtitle\" value=\"".$_POST['subtitle']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._CATEGORY.":</div><div class=\"center\"><select name=\"cid\" style=\"width: 400px\">".getcat($conf['name'], $_POST['cid'])."</select></div>"
		."<div class=\"left\">"._MYEAR.":</div><div class=\"center\"><select name=\"year\" style=\"width:400px\">";
		$date = getdate();
		$year = $date[year] - 100;
		while ($year <= $date[year]) {
			$sel = ($year == $_POST['year']) ? "selected" : "";
			echo "<option value=\"$year\" $sel>$year</option>";
			$year++;
		}
		echo "</select></div>"
		."<div class=\"left\">"._MDIRECTOR.":</div><div class=\"center\"><input type=\"text\" name=\"director\" value=\"".$_POST['director']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._MROLES.":</div><div class=\"center\"><input type=\"text\" name=\"roles\" value=\"".$_POST['roles']."\" maxlength=\"255\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._DESCRIPTION.":</div><div class=\"center\">".textarea("1", "description", "", $conf['name'], "10")."</div>"
		."<div class=\"left\">"._MCREATEDBY.":</div><div class=\"center\"><input type=\"text\" name=\"createdby\" value=\"".$_POST['createdby']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._MDURATION.":</div><div class=\"center\"><input type=\"text\" name=\"duration\" value=\"".$_POST['duration']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._LANGUAGE.":</div><div class=\"center\"><select name=\"lang\" style=\"width:400px\">";
		$lang = explode(",", $confm['lang']);
		foreach ($lang as $val) {
			$sel = ($val == $_POST['lang'] && $val != "") ? "selected" : "";
			echo "<option value=\"$val\" $sel>$val</option>";
		}
		echo "</select></div>"
		."<div class=\"left\">"._NOTE.":</div><div class=\"center\">".textarea("2", "note", "", $conf['name'], "5")."</div>"
		."<div class=\"left\">"._MFORMAT.":</div><div class=\"center\"><select name=\"format\" style=\"width:400px\">"
		."<option value=\"\">"._NO_INFO."</option>";
		$format = explode(",", $confm['format']);
		foreach ($format as $val) {
			$sel = ($val == $_POST['format'] && $val != "") ? "selected" : "";
			echo "<option value=\"$val\" $sel>$val</option>";
		}
		echo "</select></div>"
		."<div class=\"left\">"._MQUALITY.":</div><div class=\"center\"><select name=\"quality\" style=\"width:400px\">"
		."<option value=\"\">"._NO_INFO."</option>";
		$quality = explode(",", $confm['quality']);
		foreach ($quality as $val) {
			$sel = ($val == $_POST['quality'] && $val != "") ? "selected" : "";
			echo "<option value=\"$val\" $sel>$val</option>";
		}
		echo "</select></div>"
		."<div class=\"left\">"._MSIZE.":</div><div class=\"center\"><input type=\"text\" name=\"size\" value=\"".$_POST['size']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>"
		."<div class=\"left\">"._MRELEASED.":</div><div class=\"center\"><input type=\"text\" name=\"released\" value=\"".$_POST['released']."\" maxlength=\"100\" size=\"65\" style=\"width:400px\"></div>";
		$i = 0;
		while ($i < $confm['links']) {
			$a = $i + 1;
			$display = ($i != 0 && $_POST['links'][$i] == "") ? "style=\"display:none;\"" : "";
			echo "<div id=\"sub".$i."\" ".$display.">"
			."<div class=\"left\">"._URL." - $a:</div><div class=\"center\" style=\"float: left;\"><input type=\"text\" name=\"links[]\" value=\"".$_POST['links'][$i]."\" size=\"60\" style=\"width:350px\"></div><div id=\"cont\" class=\"right\"><img src=\"images/editor/plus.gif\" border=\"0\" alt=\""._ADD."\" title=\""._ADD."\" OnClick=\"SwitchMenu('sub".$a."')\" style=\"cursor:pointer;\"></div>"
			."</div>";
			$i++;
		}
		echo "".gfx_random().""
		."<div class=\"button\"><select name=\"posttype\">"
		."<option value=\"preview\">"._PREVIEW."</option>"
		."<option value=\"save\">"._SEND."</option></select>"
		."<input type=\"hidden\" name=\"op\" value=\"send\">"
		." <input type=\"submit\" value=\""._OK."\"></div></form>";
		CloseTable();
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function send() {
	global $prefix, $db, $stop, $user, $conf, $confm;
	if ((is_user($user) && $confm['add'] == 1) || (!is_user($user) && $confm['addquest'] == 1)) {
		$cid = intval($_POST['cid']);
		$title = text_filter($_POST['title']);
		$subtitle = text_filter($_POST['subtitle']);
		$year = intval($_POST['year']);
		$director = text_filter($_POST['director']);
		$roles = text_filter($_POST['roles']);
		$description = nl2br(text_filter($_POST['description']));
		$createdby = text_filter($_POST['createdby']);
		$duration = text_filter($_POST['duration']);
		$lang = text_filter($_POST['lang']);
		$note = nl2br(text_filter($_POST['note']));
		$format = text_filter($_POST['format']);
		$quality = text_filter($_POST['quality']);
		$size = text_filter($_POST['size']);
		$released = text_filter($_POST['released']);
		$placed = text_filter(substr($_POST['placed'], 0, 25));
		$links = $_POST['links'];
		$b = 0;
		foreach ($links as $val) {
			if ($val != "") {
				if ($b == 0) {
					$links = $val;
					$b++;
				} else {
					$links .= ",".$val."";
				}
			}
		}
		$links = text_filter($links);
		if (!$title) $stop = ""._CERROR."";
		if (!$description) $stop = ""._CERROR1."";
		if (!$placed && !is_user($user)) $stop = ""._CERROR3."";
		if (gfx_check()) $stop = ""._SECCODEINCOR."";
		if ($db->sql_numrows($db->sql_query("SELECT title, subtitle FROM ".$prefix."_media WHERE title='$title' AND subtitle='$subtitle'")) > 0) $stop = ""._MEDIAEXIST."";
		if (!$stop && $_POST['posttype'] == "save") {
			$db->sql_query("INSERT INTO ".$prefix."_media (id, cid, title, subtitle, year, director, roles, description, createdby, duration, lang, note, format, quality, size, released, placed, links, date, status) VALUES (NULL, '$cid', '$title', '$subtitle', '$year', '$director', '$roles', '$description', '$createdby', '$duration', '$lang', '$note', '$format', '$quality', '$size', '$released', '$placed', '$links', now(), '0')");
			update_points(19);
			head();
			menu(""._ADD."");
			warning(""._UPLOADFINISHM."", "?name=".$conf['name']."", 10, 2);
			foot();
		} else {
			add();
		}
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

switch($op) {
	default:
	media();
	break;
	
	case "liste":
	liste();
	break;
	
	case "printe":
	printe();
	break;
	
	case "view":
	view();
	break;
	
	case "broken":
	broken();
	break;
	
	case "add":
	add();
	break;
	
	case "send":
	send();
	break;

	case "save_com":
	save_com();
	break;
}
?>