<?php
if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}
get_lang($conf['name']);
include("config/config_shop.php");

function menu($logo) {
	global $conf, $confso;
	$navi = "[ <a href=\"index.php?name=".$conf['name']."\" title=\""._HOME."\">"._HOME."</a>";
	$navi .= ($confso['rate']) ? " | <a href=\"index.php?name=".$conf['name']."&best=1\" title=\""._BEST."\">"._BEST."</a> | <a href=\"index.php?name=".$conf['name']."&hits=1\" title=\""._POP."\">"._POP."</a>" : "";
	$navi .= " | <a href=\"index.php?name=".$conf['name']."&op=liste\" title=\""._LIST."\">"._LIST."</a> ]";
	search($logo, $conf['name'], $navi);
}

function shop() {
	global $prefix, $db, $pagetitle, $conf, $confso, $admin, $admin_file, $home, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$shopnum = intval($confso['num']);
	$sbest = (intval($_GET['best'])) ? 1 : 0;
	$shits = (intval($_GET['hits'])) ? 1 : 0;
	$scat = (intval($_GET['cat'])) ? $_GET['cat'] : 0;
	if ($sbest && $confso['rate']) {
		$caton = 0;
		$field = "best=1&";
		$order = "WHERE product_time <= now() AND product_active!='0' ".$lang." ORDER BY product_totalvotes DESC";
		$ordernum = "product_time <= now() AND product_active!='0'";
		$shop_logo = ""._BEST."";
		$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." $shop_logo";
	} elseif ($shits && $confso['rate']) {
		$caton = 0;
		$field = "hits=1&";
		$order = "WHERE product_time <= now() AND product_active!='0' ".$lang." ORDER BY product_count DESC";
		$ordernum = "product_time <= now() AND product_active!='0'";
		$shop_logo = ""._POP."";
		$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." $shop_logo";
	} elseif ($scat) {
		$caton = 1;
		$field = "cat=$scat&";
		list($cat_title, $cat_description) = $db->sql_fetchrow($db->sql_query("SELECT title, description FROM ".$prefix."_categories WHERE id='$scat'"));
		$order = "WHERE product_cid='$scat' AND product_time <= now() AND product_active!='0' ".$lang." ORDER BY product_time DESC";
		$ordernum = "product_cid='$scat' AND product_time <= now() AND product_active!='0'";
		$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." $cat_title";
	} else {
		$caton = 1;
		$field = "";
		$order = "WHERE product_time <= now() AND product_active!='0' ".$lang." ORDER BY product_time DESC";
		$ordernum = "product_time <= now() AND product_active!='0'";
		$shop_logo = ""._SHOP."";
		$pagetitle = "".$conf['defis']." $shop_logo";
	}
	head();
	if (!$home) {
		if ($scat) {
			menu($cat_title);
		} else {
			menu($shop_logo);
		}
		if ($caton == 1) categories($conf['name'], $confso['col'], $confso['sub'], $confso['desc'], $scat);
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $shopnum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT p.product_id, p.product_cid, p.product_time, p.product_title, p.product_text, p.product_preis, p.product_com, p.product_count, p.product_votes, p.product_totalvotes, c.id, c.title, c.description, c.img FROM ".$prefix."_products AS p LEFT JOIN ".$prefix."_categories AS c ON (p.product_cid=c.id) ".$order." LIMIT $offset, $shopnum");
	if ($db->sql_numrows($result) > 0) {
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script><script type=\"text/javascript\" src=\"ajax/Shop.js\"></script><script type=\"text/javascript\">ajax('ajax.php?go=2', 'ajax');</script><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\"><tr><td><div id=\"shop\"><div id=\"ajax\"></div></div></td></tr></table>";
		while (list($product_id, $product_cid, $product_time, $product_title, $product_text, $product_preis, $product_com, $product_count, $product_votes, $product_totalvotes, $cid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result)) {
			$title = "<a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id\" title=\"$product_title\">".$product_title."</a>";
			$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"left\"><a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id\" title=\"$product_title\"><b>"._READMORE."</b></a> | <b>"._PREIS.": ".$product_preis." ".$confso['valute']."</b>";
			if ($confso['date']) $link .= " | "._DATE.": ".formatTimestamp($product_time)."";
			if ($confso['read']) $link .= " | "._READS.": ".$product_count."";
			if ($confso['comm']) {
				if ($product_com == 0) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id#$product_id\" title=\"$product_title\">"._COMMENTS."</a>";
				} elseif ($product_com == 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id#$product_id\" title=\"$product_title\">"._COMMENT.": $product_com</a>";
				} elseif ($product_com > 1) {
					$link .= " | <a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id#$product_id\" title=\"$product_title\">"._COMMENTS.": $product_com</a>";
				}
			}
			if ($confso['votes']) $link .= (!$confso['votein']) ? "</td><td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$product_id', 'rate".$product_id."');</script><div class=\"rate\" id=\"rate".$product_id."\"></div></td>" : "</td><td><div class=\"rate\">".vote_graphic($product_votes, $product_totalvotes)."</div></td>";
			$link .= "<td align=\"right\"><img src=\"images/blocks/Cart.gif\" style=\"cursor: pointer;\" OnClick=\"ajax('ajax.php?go=2&op=AddKasse&id=$product_id', 'ajax'); AddBasket($product_id);\" border=\"0\" alt=\""._SCART."\" title=\""._SCART."\" align=\"center\"> <a href=\"index.php?name=".$conf['name']."&op=kasse\"><img src=\"images/blocks/Shop.gif\" border=\"0\" alt=\""._SCACH."\" title=\""._SCACH."\" align=\"center\"></a> <a href=\"index.php?name=".$conf['name']."&op=printe&id=$product_id\"><img src=\"images/blocks/Print.gif\" border=\"0\" alt=\""._PRINTER."\" title=\""._PRINTER."\" align=\"center\"></a>";
			if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=shop_add_products&id=$product_id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
			$link .= "</td></tr></table>";
			$cdescription = ($cdescription) ? $cdescription : $ctitle;
			$cimg = ($cimg) ? "<a href=\"index.php?name=".$conf['name']."&cat=$cid\"><img src=\"images/categories/".$cimg."\" border=\"0\" alt=\"$cdescription\" title=\"$cdescription\" align=\"right\" hspace=\"10\" vspace=\"10\"></a>" : "";
			basic($product_id, $product_time, $title, $product_count, bb_decode($product_text, $conf['name']), $link, $cid, $cimg, $ctitle);
		}
		num_article($conf['name'], $shopnum, $field, "product_id", "_products", "product_cid", $ordernum);
	}
	foot();
}

function liste() {
	global $db, $prefix, $pagetitle, $conf, $confso, $currentlang;
	$lang = ($conf['multilingual']) ? "AND (c.language='$currentlang' OR c.language='')" : "";
	$slistnum = intval($confso['listnum']);
	$let = (!preg_match("/[^a-zA-Z--0-9]/", $_GET['let'])) ? $_GET['let'] : "";
	if ($let) {
		$field = "op=liste&let=".urlencode($let)."&";
		$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." "._LIST." ".$conf['defis']." $let";
		$order = "WHERE UPPER(product_title) LIKE '".$let."%' AND product_time <= now() AND product_active!='0'";
	} else {
		$field = "op=liste&";
		$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." "._LIST."";
		$order = "WHERE product_time <= now() AND product_active!='0'";
	}
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $slistnum;
	$offset = intval($offset);
	$result = $db->sql_query("SELECT p.product_id, p.product_cid, p.product_time, p.product_title, p.product_preis, c.id, c.title FROM ".$prefix."_products AS p LEFT JOIN ".$prefix."_categories AS c ON (p.product_cid=c.id) ".$order." ".$lang." ORDER BY p.product_time DESC LIMIT $offset, $slistnum");
	head();
	menu(""._LIST."");
	if ($db->sql_numrows($result) > 0) {
		OpenTable();
		if ($confso['letter']) letter($conf['name']);
		echo "<script language=\"JavaScript\" type=\"text/javascript\" src=\"ajax/SortTable.js\"></script><table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
		."<th>"._ID."</th><th>"._TITLE."</th><th>"._CATEGORY."</th><th>"._DATE."</th><th>"._PREIS."</th></tr>";
		while (list($product_id, $product_cid, $product_time, $product_title, $product_preis, $cid, $ctitle) = $db->sql_fetchrow($result)) {
			$ctitle = (!$ctitle) ? ""._NO."" : "<a href=\"index.php?name=".$conf['name']."&cat=$cid\" title=\"".$ctitle."\">".cutstr($ctitle, 10)."</a>";
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".$product_id."</td>"
			."<td><a href=\"index.php?name=".$conf['name']."&op=view&id=$product_id\" title=\"".$product_title."\">".cutstr($product_title, 50)."</a></td>"
			."<td align=\"center\">".$ctitle."</td>"
			."<td align=\"center\">".formatTimestamp($product_time)."</td>"
			."<td align=\"center\">".$product_preis." ".$confso['valute']."</td></tr>";
		}
		echo "</table>";
		CloseTable();
		$ordernum = ($let) ? "UPPER(product_title) LIKE '".$let."%' AND product_time <= now() AND product_active!='0'" : "product_time <= now() AND product_active!='0'";
		num_article($conf['name'], $slistnum, $field, "product_id", "_products", "product_cid", $ordernum);
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function printe() {
	global $prefix, $db, $pagetitle, $conf;
	$id = intval($_GET['id']);
	$result = $db->sql_query("SELECT product_time, product_title, product_text, product_desc FROM ".$prefix."_products WHERE product_id='$id' AND product_time <= now() AND product_active!='0'");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_products SET product_count=product_count+1 WHERE product_id='$id'");
		list($date, $product_title, $hometext, $bodytext) = $db->sql_fetchrow($result);
		$ThemeSel = get_theme();
		if (file_exists("templates/$ThemeSel/index.php")) {
			require_once("templates/$ThemeSel/index.php");
		} else {
			require_once("function/template.php");
		}
		$conf['defis'] = urldecode($conf['defis']);
		$title = "$product_title ".$conf['defis']." "._SHOP." ".$conf['defis']." ".$conf['sitename']."";
		$ptitle = "".formatTimestamp($date)." - ".$product_title."";
		$text = ($bodytext) ? "".bb_decode($hometext, $conf['name'])."<br /><br />".bb_decode($bodytext, $conf['name'])."" : bb_decode($hometext, $conf['name']);
		$url = ""._COMESFROM.": <a href=\"".$conf['homeurl']."\" title=\"".$conf['sitename']."\">".$conf['homeurl']."</a><br />"._THEURL.": <a href=\"".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$product_title."\">".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id</a>";
		prints($title, $ptitle, $text, $url);
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function view() {
	global $db, $prefix, $pagetitle, $conf, $confso, $admin, $admin_file, $hometext, $bodytext;
	$id = intval($_GET['id']);
	$word = ($_GET['word']) ? text_filter($_GET['word']) : "";
	$result = $db->sql_query("SELECT p.product_id, p.product_cid, p.product_time, p.product_title, p.product_text, p.product_desc, p.product_preis, p.product_assoc, p.product_com, p.product_count, p.product_votes, p.product_totalvotes, c.id, c.title, c.description, c.img FROM ".$prefix."_products AS p LEFT JOIN ".$prefix."_categories AS c ON (p.product_cid=c.id) WHERE product_id = '$id' AND product_time <= now() AND product_active!='0'");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_products SET product_count=product_count+1 WHERE product_id='$id'");
		list($product_id, $product_cid, $product_time, $product_title, $product_text, $product_desc, $product_preis, $product_assoc, $product_com, $product_count, $product_votes, $product_totalvotes, $cid, $ctitle, $cdescription, $cimg) = $db->sql_fetchrow($result);
		$hometext = $product_text;
		$bodytext = $product_desc;
		$pagetitle = (intval($cid)) ? "".$conf['defis']." "._SHOP." ".$conf['defis']." $ctitle ".$conf['defis']." $product_title" : "".$conf['defis']." "._SHOP." ".$conf['defis']." $product_title";
		head();
		menu(""._SHOP."");
		echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script><script type=\"text/javascript\" src=\"ajax/Shop.js\"></script><script type=\"text/javascript\">ajax('ajax.php?go=2', 'ajax');</script><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\"><tr><td><div id=\"shop\"><div id=\"ajax\"></div></div></td></tr></table>";
		$link = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"left\"><b>"._PREIS.": ".$product_preis." ".$confso['valute']."</b>";
		if ($confso['date']) $link .= " | "._DATE.": ".formatTimestamp($product_time)."";
		if ($confso['read']) $link .= " | "._READS.": ".$product_count."";
		if ($confso['votes']) $link .= "</td><td><script type=\"text/javascript\">ajax('ajax.php?go=1&op=Rating&mod=".$conf['name']."&id=$product_id', 'rate".$product_id."');</script><div class=\"rate\" id=\"rate".$product_id."\"></div></td>";
		$text = ($product_desc) ? "".bb_decode($product_text, $conf['name'])."<br /><br />".bb_decode($product_desc, $conf['name'])."" : bb_decode($product_text, $conf['name']);
		$link .= "<td align=\"right\"><img src=\"images/blocks/Cart.gif\" style=\"cursor: pointer;\" OnClick=\"ajax('ajax.php?go=2&op=AddKasse&id=$product_id', 'ajax'); AddBasket($product_id);\" border=\"0\" alt=\""._SCART."\" title=\""._SCART."\" align=\"center\"> <a href=\"index.php?name=".$conf['name']."&op=kasse\"><img src=\"images/blocks/Shop.gif\" border=\"0\" alt=\""._SCACH."\" title=\""._SCACH."\" align=\"center\"></a> <a href=\"index.php?name=".$conf['name']."&op=printe&id=$product_id\"><img src=\"images/blocks/Print.gif\" border=\"0\" alt=\""._PRINTER."\" title=\""._PRINTER."\" align=\"center\"></a>";
		if (is_admin($admin)) $link .= " <a href=\"".$admin_file.".php?op=shop_add_products&id=$product_id\" title=\""._EDIT."\"><img src=\"images/edit.gif\" border=\"0\" align=\"center\"></a>";
		$link .= "</td></tr></table>";
		$cimg = ($cimg) ? "<a href=\"index.php?name=".$conf['name']."&cat=$cid\"><img src=\"images/categories/".$cimg."\" border=\"0\" alt=\"$cdescription\" title=\"$cdescription\" align=\"right\" hspace=\"10\" vspace=\"10\"></a>" : "";
		basic($product_id, $product_time, search_color($product_title, $word), $product_count, search_color(bb_decode($text, $conf['name']), $word), $link, $cid, $cimg, $ctitle);
		if ($confso['assoc']) {
			if ($product_assoc[strlen($product_assoc)-1] == "-") $product_assoc = substr($product_assoc, 0, -1);
			$asso = str_replace("-", ",", $product_assoc);
			$limit = intval($confso['assocnum']);
			$result = $db->sql_query("SELECT product_id, product_title, product_time FROM ".$prefix."_products WHERE product_cid IN (".$asso.") AND product_id!='$product_id' AND product_time <= now() AND product_active!='0' ORDER BY product_time DESC LIMIT 0, ".$limit."");
			if ($db->sql_numrows($result) > 0) {
				OpenTable();
				echo "<h2>"._ASPROD."</h2>"
				."<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";
				while(list($s_sid, $title, $time) = $db->sql_fetchrow($result)) {
					echo "<tr><td><a href=\"index.php?name=".$conf['name']."&op=view&id=$s_sid\" title=\"$title\"><img src=\"images/blocks/News.gif\" border=\"0\"></a></td><td>".formatTimestamp($time)." - <a href=\"index.php?name=".$conf['name']."&op=view&id=$s_sid\" title=\"$title\">$title</a></td></tr>";
				}
				echo "</table>";
				CloseTable();
			}
		}
		if ($confso['comm']) {
			echo "<a name=\"$product_id\"></a>";
			show_com($product_id);
		}
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function kasse() {
	global $user, $prefix, $db, $pagetitle, $conf, $confu, $confso, $stop, $userinfo;
	$opi = (intval($_POST['opi'])) ? 1 : 0;
	getusrinfo($user);
	$sender_id = (is_user($user)) ? $userinfo['user_id'] : 0;
	$sender_login = (is_user($user)) ? $userinfo['user_name'] : $confu['anonym'];
	$sender_email = (is_user($user) && !isset($_POST['sender_email'])) ? $userinfo['user_email'] : $_POST['sender_email'];
	$sender_dom = (is_user($user) && !isset($_POST['sender_dom'])) ? $userinfo['user_website'] : $_POST['sender_dom'];
	$sender_name = $_POST['sender_name'];
	$sender_adr = $_POST['sender_adr'];
	$sender_tel = $_POST['sender_tel'];
	$sender_message = text_filter($_POST['sender_message']);
	$cookies = (preg_match("/[^0-9,]/", base64_decode($_COOKIE['Shop']))) ? "" : base64_decode($_COOKIE['Shop']);
	$id_partner = (intval($_COOKIE['Part'])) ? $_COOKIE['Part'] : "";
	$stop = (!$cookies) ? ""._SERRORP."" : "";
	$form_block = "<form method=\"post\" action=\"index.php?name=".$conf['name']."\">"
	."<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\" class=\"bgcolor4\" align=\"center\">"
	."<tr class=\"bgcolor1\"><th colspan=\"2\" align=\"center\">"._C_TITLE."</th></tr>"
	."<tr class=\"bgcolor1\"><td>"._C_PIN." <font class=\"option\">*</font></td><td><input type=\"text\" name=\"sender_name\" value=\"$sender_name\" size=\"65\" style=\"width:400px\"> <br /><i>"._C_PINB."</i></td></tr>"
	."<tr class=\"bgcolor1\"><td>"._C_PIP." <font class=\"option\">*</font></td><td><input type=\"text\" name=\"sender_adr\" value=\"$sender_adr\" size=\"65\" style=\"width:400px\"> <br /><i>"._C_PIPB."</i></td></tr>"
	."<tr class=\"bgcolor1\"><td>"._C_TEL." <font class=\"option\">*</font></td><td><input type=\"text\" name=\"sender_tel\" value=\"$sender_tel\" size=\"65\" style=\"width:400px\"> <br /><i>"._C_TELB."</i></td></tr>"
	."<tr class=\"bgcolor1\"><td>"._C_MAIL." <font class=\"option\">*</font></td><td><input type=\"text\" name=\"sender_email\" value=\"$sender_email\" size=\"65\" style=\"width:400px\"> <br /><i>"._C_MAILB."</i></td></tr>"
	."<tr class=\"bgcolor1\"><td>"._SDOM." <font class=\"option\">*</font></td><td><input type=\"text\" name=\"sender_dom\" value=\"$sender_dom\" size=\"65\" style=\"width:400px\"> <br /><i>"._SDOMB."</i></td></tr>"
	."<tr class=\"bgcolor1\"><td>"._C_MESSAGE."</td><td><textarea name=\"sender_message\" cols=\"65\" rows=\"5\" style=\"width:400px\">$sender_message</textarea></tr>"
	."<tr class=\"bgcolor1\"><td colspan=\"2\" align=\"center\"><input type=\"hidden\" name=\"opi\" value=\"1\"><input type=\"hidden\" name=\"op\" value=\"kasse\"><input type=\"submit\" value=\""._C_SEND."\"></td></tr></form></table>";
	$pagetitle = "".$conf['defis']." "._SHOP." ".$conf['defis']." "._C_TITLE."";
	head();
	menu(""._C_TITLE."");
	echo "<script type=\"text/javascript\" src=\"ajax/Ajax.js\"></script><script type=\"text/javascript\" src=\"ajax/Shop.js\"></script><script type=\"text/javascript\">ajax('ajax.php?go=2', 'ajax');</script><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\"><tr><td><div id=\"shop\"><div id=\"ajax\"></div></div></td></tr></table>";
	if (!$opi && $cookies) {
		OpenTable();
		echo "$form_block";
		CloseTable();
	} elseif ($opi && $cookies) {
		checkemail($sender_email);
		if (!$sender_name || !$sender_adr || !$sender_tel || !$sender_email || !$sender_dom) {
			$stop = ""._SERROR."";
		} elseif ($stop) {
			$stop = "$stop";
		}
		if (!$stop) {
			$result = $db->sql_query("SELECT product_id, product_title, product_preis FROM ".$prefix."_products WHERE product_id IN ($cookies)");
			while(list($id, $title, $preis) = $db->sql_fetchrow($result)) {
				$massiv = explode(",", $cookies);
				$i = 0;
				foreach ($massiv as $val) {
					if ($val == $id) $i++;
				}
				$preis = $preis * $i;
				$preistotal += $preis;
				$content .= "<tr><td align=\"center\">".$id."</td><td align=\"center\">".$i."</td><td>".$title."</td><td align=\"center\">".$preis." ".$confso['valute']."</td></td></tr>";
			}
			$product_info = "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tr>"
			."<th>"._ID."</th><th>"._QUANTITY."</th><th>"._PRODUCT."</th><th>"._PREIS."</th></tr>".$content.""
			."<tr><td align=\"right\" colspan=\"5\"><br /><b>"._PARTNERGES.": ".$preistotal." ".$confso['valute']."</b></td></tr></table>";
			if ($confso['mailsend']) {
				$amail = ($confso['mail']) ? $confso['mail'] : $conf['adminmail'];
				$subject = "".$conf['sitename']." - "._C_TITLE."";
				$msg = "".$conf['sitename']." - "._C_TITLE."<br /><br />";
				$msg .= "$product_info<br /><br />";
				$msg .= "<b>"._PERSONALINFO."</b><br /><br />";
				$msg .= ""._NICKNAME.": $sender_login<br />";
				$msg .= ""._C_PIN.": $sender_name<br />";
				$msg .= ""._C_PIP.": $sender_adr<br />";
				$msg .= ""._C_TEL.": $sender_tel<br />";
				$msg .= ""._C_MAIL.": $sender_email<br />";
				$msg .= ""._SITEURL.": $sender_dom<br />";
				$msg .= ""._C_MESSAGE.": $sender_message";
				mail_send($amail, $sender_email, $subject, $msg, 1, 1);
			}
			if ($confso['mailuser']) {
				$amail = ($confso['mail']) ? $confso['mail'] : $conf['adminmail'];
				$subject = "".$conf['sitename']." - "._C_TITLE."";
				$msg = "".$conf['sitename']." - "._C_TITLE."<br /><br />";
				$msg .= "".bb_decode($confso['sende'], $conf['name'])."<br /><br />";
				$msg .= "$product_info<br /><br />";
				$msg .= "<b>"._PERSONALINFO."</b><br /><br />";
				$msg .= ""._NICKNAME.": $sender_login<br />";
				$msg .= ""._C_PIN.": $sender_name<br />";
				$msg .= ""._C_PIP.": $sender_adr<br />";
				$msg .= ""._C_TEL.": $sender_tel<br />";
				$msg .= ""._C_MAIL.": $sender_email<br />";
				$msg .= ""._SDOM.": $sender_dom<br />";
				$msg .= ""._C_MESSAGE.": $sender_message";
				mail_send($sender_email, $amail, $subject, $msg, 0, 3);
			}
			$massiv = explode(",", $cookies);
			foreach ($massiv as $val) {
				if ($val != "") {
					$sender_regdate = time();
					$db->sql_query("INSERT INTO ".$prefix."_clients VALUES(NULL, '$sender_id', '$val', '$id_partner', '0', '$sender_name', '$sender_adr', '$sender_tel', '$sender_email', '$sender_dom', '$sender_regdate', '0', '0', '2')");
				}
			}
			setcookie("Shop", false);
			update_points(26);
			OpenTable();
			echo "".bb_decode($confso['sende'], $conf['name'])."";
			CloseTable();
		} else {
			warning($stop, "", "", 1);
			OpenTable();
			echo "$form_block";
			CloseTable();
		}
	} else {
		warning($stop, "?name=".$conf['name']."", 5, 1);
	}
	foot();
}

function part() {
	global $conf, $confso;
	$id = (isset($_GET['id'])) ? intval($_GET['id']) : "";
	if ($id) setcookie("Part", $id, time() + $confso['part_t']);
	Header("Location: index.php?name=".$conf['name']."");
}

switch($op) {
	default:
	shop();
	break;
	
	case "liste":
	liste();
	break;

	case "printe":
	printe();
	break;

	case "view":
	view();
	break;

	case "kasse":
	kasse();
	break;

	case "part":
	part();
	break;

	case "save_com":
	save_com();
	break;
}
?>