<?php
define("MODULE_FILE", true);
include("function/function.php");
get_lang();
Header("Content-Type: application/rss+xml");
Header("Content-Encoding: none");

echo "<?xml version=\"1.0\" encoding=\""._CHARSET."\"?>\n"
."<rss version=\"2.0\">\n"
."<channel>\n"
."<title>".htmlspecialchars($conf['sitename'])."</title>\n"
."<link>".$conf['homeurl']."</link>\n"
."<description>".htmlspecialchars($conf['slogan'])."</description>\n"
."<generator>SLAED CMS ".$conf['version']."</generator>\n"
."<copyright>Copyright (c) SLAED CMS ".$conf['version']."</copyright>\n"
."<language>".htmlspecialchars(substr(""._LOCALE."", 0, 2))."</language>\n"
."<lastBuildDate>".date("D, j M Y H:m:s O")."</lastBuildDate>\n\n";

if (intval($_GET['limit']) || intval($_POST['limit'])) {
	$limit = substr(trim(isset($_POST['limit']) ? $_POST['limit'] : $_GET['limit']), 0, 2);
	if (preg_match("/[^0-9]/", $limit)) $limit = "10";
} else {
	$limit = "10";
}
if (intval($_GET['cat']) || intval($_POST['cat'])) {
	$cat = substr(trim(isset($_POST['cat']) ? $_POST['cat'] : $_GET['cat']), 0, 3);
	if (preg_match("/[^0-9]/", $cat)) $cat = "";
} else {
	$cat = "";
}
if (isset($_GET['mod']) || isset($_POST['mod'])) {
	$mod = substr(trim(isset($_POST['mod']) ? $_POST['mod'] : $_GET['mod']), 0, 25);
	if (preg_match("/[^a-zA-Z0-9_]/", $mod)) $mod = "";
} else {
	$mod = "";
}

if ($mod == "Files" || $conf['module'] == "Files") {
	$where = ($cat) ? "WHERE cid='$cat' AND date<=now() AND status !='0'" : "WHERE date<=now() AND status !='0'";
	$result = $db->sql_query("SELECT lid, title, description, date FROM ".$prefix."_files ".$where." ORDER BY date DESC LIMIT ".$limit."");
	while (list($rlid, $rtitle, $rdescription, $rdate) = $db->sql_fetchrow($result)) {
		echo "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<guid>".$conf['homeurl']."/index.php?name=Files&amp;op=view&amp;id=$rlid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rdescription, "Files"))."</description>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rdate)))."</pubDate>\n"
		."<comments>".$conf['homeurl']."/index.php?name=Files&amp;op=view&amp;id=$rlid#$rlid</comments>\n"
		."</item>\n\n";
	}
} elseif ($mod == "Links" || $conf['module'] == "Links") {
	$where = ($cat) ? "WHERE cid='$cat' AND date<=now() AND status !='0'" : "WHERE date<=now() AND status !='0'";
	$result = $db->sql_query("SELECT lid, title, description, date FROM ".$prefix."_links ".$where." ORDER BY date DESC LIMIT ".$limit."");
	while (list($rlid, $rtitle, $rdescription, $rdate) = $db->sql_fetchrow($result)) {
		echo "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<guid>".$conf['homeurl']."/index.php?name=Links&amp;op=view&amp;id=$rlid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rdescription, "Links"))."</description>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rdate)))."</pubDate>\n"
		."</item>\n\n";
	}
} elseif ($mod == "Media" || $conf['module'] == "Media") {
	$where = ($cat) ? "WHERE cid='$cat' AND date<=now() AND status !='0'" : "WHERE date<=now() AND status !='0'";
	$result = $db->sql_query("SELECT id, title, subtitle, description, date FROM ".$prefix."_media ".$where." ORDER BY date DESC LIMIT ".$limit."");
	while (list($rid, $rtitle, $rsubtitle, $rdescription, $rdate) = $db->sql_fetchrow($result)) {
		include("config/config_media.php");
		$rtitle = ($rsubtitle) ? "".$rtitle." ".urldecode($confm['defis'])." ".$rsubtitle."" : $rtitle;
		echo "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<guid>".$conf['homeurl']."/index.php?name=Media&amp;op=view&amp;id=$rid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rdescription, "Media"))."</description>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rdate)))."</pubDate>\n"
		."</item>\n\n";
	}
} elseif ($mod == "Shop" || $conf['module'] == "Shop") {
	$where = ($cat) ? "WHERE product_cid='$cat' AND product_time<=now() AND product_active ='1'" : "WHERE product_time<=now() AND product_active ='1'";
	$result = $db->sql_query("SELECT product_id, product_time, product_title, product_text FROM ".$prefix."_products ".$where." ORDER BY product_time DESC LIMIT ".$limit."");
	while (list($rid, $rdate, $rtitle, $rdescription) = $db->sql_fetchrow($result)) {
		include("config/config_media.php");
		echo "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<guid>".$conf['homeurl']."/index.php?name=Shop&amp;op=view&amp;id=$rid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rdescription, "Shop"))."</description>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rdate)))."</pubDate>\n"
		."</item>\n\n";
	}
} elseif ($conf['module'] == "News") {
	$where = ($cat) ? "WHERE catid='$cat' AND time<=now() AND status!='0'" : "WHERE time<=now() AND status!='0'";
	$result = $db->sql_query("SELECT s.sid, s.aid, s.title, s.time, s.hometext, c.title FROM ".$prefix."_stories AS s LEFT JOIN ".$prefix."_categories AS c ON (s.catid=c.id) ".$where." ORDER BY time DESC LIMIT ".$limit."");
	while (list($rsid, $raid, $rtitle, $rtime, $rhometext, $rctitle) = $db->sql_fetchrow($result)) {
		echo "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rtime)))."</pubDate>\n"
		."<guid>".$conf['homeurl']."/index.php?name=News&amp;op=view&amp;id=$rsid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rhometext, "News"))."</description>\n"
		."<comments>".$conf['homeurl']."/index.php?name=News&amp;op=view&amp;id=$rsid#$rsid</comments>\n"
		."<category>".htmlspecialchars($rctitle)."</category>\n"
		."<author>antispam@antispam.com (".htmlspecialchars($raid).")</author>\n"
		."</item>\n\n";
	}
}
echo "</channel>\n"
."</rss>";
?>