<?php
if (!defined("SETUP_FILE")) die("Illegal File Access");
define("FUNC_FILE", true);
error_reporting(0);

include("config/config_global.php");
include("function/zend.php");

if (!ini_get("register_globals")) import_request_variables('GPC');

$is_safe_mode = (ini_get('safe_mode') == "1") ? 1 : 0;
if (!$is_safe_mode && function_exists('set_time_limit')) set_time_limit(600);

if (isset($_COOKIE["lang"])) {
	include("setup/language/lang-".$_COOKIE["lang"].".php");
} else {
	include("setup/language/lang-english.php");
}

function head() {
	global $title;
	$style = (file_exists("templates/Stability/style.css")) ? "templates/Stability/style.css" : "templates/Default/style.css";
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
	."<html>\n"
	."<head>\n"
	."<meta http-equiv=\"content-type\" content=\"text/html; charset="._CHARSET."\">\n"
	."<title>"._SETUP_SLAED_SMC."</title>\n"
	."<link rel=\"stylesheet\" href=\"".$style."\" type=\"text/css\">\n"
	."</head>\n"
	."<body>\n"
	."<br /><br /><br /><table width=\"60%\" align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
	."<tr><td align=\"center\"><img src=\"images/logos/Logo.gif\" border=\"0\" title=\"SLAED CMS\"></td></tr><tr><td align=\"center\"><br><br><br><font class=\"option\">$title</font><br><br></td></tr><tr><td>\n";
}

function foot() {
	echo "</td></tr></table>\n"
	."</body>\n"
	."</html>";
}

function language() {
	global $title;
	$title = (phpversion() < "4.3.0") ? ""._PHPSETUP."" : ""._LANG."";
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\"><tr>"
	."<td><a href=\"setup.php?op=english\" title=\"English\"><img src=\"images/language/flag-english.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=english\" title=\"English\">English</a></td>"
	."<td><a href=\"setup.php?op=german\" title=\"German\"><img src=\"images/language/flag-german.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=german\" title=\"German\">German</a></td>"
	."<td><a href=\"setup.php?op=russian\" title=\"Russian\"><img src=\"images/language/flag-russian.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=russian\" title=\"Russian\">Russian</a></td>"
	."</tr>";
	if (isset($_GET["lang"]) && $_GET["lang"] == 1) {
		echo "<tr><td align=\"center\" colspan=\"6\"><br><br><form action=\"setup.php\" method=\"post\">"
		."<input type=\"hidden\" name=\"op\" value=\"license\">"
		."<input type=\"submit\" value=\""._NEXT."\"></td></tr>";
	}
	echo "</table>";
	foot();
}

function license() {
	global $title;
	$title = ""._LICENSE."";
	head();
	if (isset($_COOKIE["lang"])) {
		$bodytext = file_get_contents("setup/doc/lang-".$_COOKIE["lang"].".txt");
	} else {
		$bodytext = file_get_contents("setup/doc/lang-english.txt");
	}
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
	."<tr><td><textarea cols=\"45\" rows=\"15\" style=\"width:400px\">$bodytext</textarea></td></tr>"
	."<tr><td><form action=\"setup.php\" method=\"post\"><input type=\"checkbox\" name=\"license_check\" value=\"1\">"._LICENSE_OK."</td></tr>"
	."<tr><td align=\"center\"><br><br>"._GOBACK." <input type=\"hidden\" name=\"op\" value=\"config\">"
	."<input type=\"submit\" value=\""._NEXT."\"></td></tr>"
	."</table>";
	foot();
}

function config() {
	global $title;
	$title = ""._CONFIG."";
	if (file_exists('config/config.php')) {
		@chmod('config/config.php', 0666);
		$permsdir = decoct(fileperms("config/config.php"));
		$perms = substr("$permsdir",-3);
		if ($perms != "666") {
			$title = ""._FILE." config/config.php "._ERRORPERM." CHMOD - 666";
			head();
			foot();
			exit;
		}
	}
	if (file_exists('config/config_global.php')) {
		@chmod('config/config_global.php', 0666);
		$permsdir = decoct(fileperms("config/config_global.php"));
		$perms = substr("$permsdir",-3);
		if ($perms != "666") {
			$title = ""._FILE." config/config_global.php "._ERRORPERM." CHMOD - 666";
			head();
			foot();
			exit;
		}
	}
	$license_check = isset($_POST["license_check"]);
	if ($license_check == "1") {
		head();
		echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
		."<form action=\"setup.php\" method=\"post\">"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._SETUP_NEW.":</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"new\" checked></td></tr>"
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_1.":</td><td align=\"right\"><input type=\"text\" name=\"xdbhost\" value=\"localhost\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_2.":</td><td align=\"right\"><input type=\"text\" name=\"xdbuname\" value=\"root\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_3.":</td><td align=\"right\"><input type=\"text\" name=\"xdbpass\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_4.":</td><td align=\"right\"><input type=\"text\" name=\"xdbname\" size=\"25\"></td></tr>"
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_5.":</td><td align=\"right\"><input type=\"text\" name=\"xadmin_file\" value=\"admin\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_6.":</td><td align=\"right\"><input type=\"text\" name=\"xprefix\" value=\"slaed\" size=\"25\"></td></tr>"
		."<tr><td align=\"center\" colspan=\"2\"><br><br>"._GOBACK." <input type=\"hidden\" name=\"op\" value=\"save\">"
		."<input type=\"submit\" value=\""._NEXT."\"></td></tr>"
		."</table></td></tr>";
		echo "</table>";
		foot();
	} else {
		license();
	}
}

function save($setup, $xdbhost, $xdbuname, $xdbpass, $xdbname, $xadmin_file, $xprefix) {
	global $title;
	require_once("config/config_global.php");
	$bodytext = "";
	$conectionid = @mysql_connect($xdbhost, $xdbuname, $xdbpass);
	if ($conectionid) {
		$db = @mysql_select_db($xdbname);
		if (!$db) {
			$title = ""._ERROR."";
			head();
			echo "<br><br><center>"._GOBACK."</center>";
			foot();
			exit;
		}
		if ($setup == "new") {
			$title = ""._SAVE_NEW."";
			$filename = "setup/sql/table.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
			$filename = "setup/sql/insert.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id2 = mysql_query($string);
				if (eregi("CREATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id2) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		}
		mysql_close($conectionid);
		
		@include("config/config.php");
		$temp_file = (isset($admin_file)) ? $admin_file : "admin";
		
		$fp = fopen("config/config.php", "wb");
		$content = "<?php\n";
		$content .= "if (!defined(\"FUNC_FILE\")) die(\"Illegal File Access\");\n";
		$content .= "\n";
		$content .= "\$dbhost = \"$xdbhost\";\n";
		$content .= "\$dbuname = \"$xdbuname\";\n";
		$content .= "\$dbpass = \"$xdbpass\";\n";
		$content .= "\$dbname = \"$xdbname\";\n";
		$content .= "\n";
		$content .= "\$admin_file = \"$xadmin_file\";\n";
		$content .= "\$prefix = \"$xprefix\";\n";
		$content .= "\n";
		$content .= "?>";
		fwrite($fp, $content);
		fclose($fp);
		
		@include("config/config_global.php");
		$content = file_get_contents('config/config_global.php');
		if (isset($_COOKIE["lang"])) $content = str_replace("\$conf['language'] = \"".$conf['language']."\";", "\$conf['language'] = \"".$_COOKIE["lang"]."\";", $content);
		$content = str_replace("\$conf['homeurl'] = \"".$conf['homeurl']."\";", "\$conf['homeurl'] = \"http://".$_SERVER["SERVER_NAME"]."\";", $content);
		$fp = fopen("config/config_global.php", "wb");
		fwrite($fp, $content);
		fclose($fp);
		
		@rename(''.$temp_file.'.php', ''.$xadmin_file.'.php');
		$bodytext .= "<tr><td colspan=\"2\">"._CONF_FILE.":</td><td><font color=\"green\">"._OK."</font></td></tr>";
	} else {
		$title = ""._ERROR2."";
		head();
		echo "<br><br><center>"._GOBACK."</center>";
		foot();
		exit;
	}
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">".$bodytext."</table>"
	."<form action=\"".$xadmin_file.".php\" method=\"post\"><br /><center>"._GOBACK." <input type=\"submit\" value=\""._ADMIN."\"></center></form>";
	foot();
}
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : "";
switch($op) {
	default:
	language();
	break;

	case "english":
	setcookie ("lang", "english", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "german":
	setcookie ("lang", "german", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "russian":
	setcookie ("lang", "russian", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "license":
	license();
	break;

	case "config":
	config();
	break;

	case "save":
	save($setup, $xdbhost, $xdbuname, $xdbpass, $xdbname, $xadmin_file, $xprefix);
	break;
}
?>